SpamageMeters = LibStub("AceAddon-3.0"):NewAddon("SpamageMeters", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("SpamageMeters")

local defaults = {
    profile =  {
	filterGuild = 2,
	filterOfficer = 2,
	filterParty = 2,
	filterRaid = 2,
	filterSay = 2,
	filterWhisper = 2,
	filterYell = 2,
	debug = true,
    },
}

local options = {
	name = "SpamageMeters",
	handler = SpamageMeters,
	type = "group",
	args = {
		debug = {
			type = "toggle",
			name = L["Enable Debug"],
			desc = L["Enable the debug function"],
			set = function(info, value)
				SpamageMeters.db.profile.debug = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.debug
			end
		},
        	filterGuild = {
			type = "select",
			name = L["Filter Guild"],
			desc = L["Selects the action to perform when encountering damage meter data in guild chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterGuild = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterGuild
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterOfficer = {
			type = "select",
			name = L["Filter Officer"],
			desc = L["Selects the action to perform when encountering damage meter data in officer chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterOfficer = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterOfficer
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterParty = {
			type = "select",
			name = L["Filter Party"],
			desc = L["Selects the action to perform when encountering damage meter data in party chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterParty = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterParty
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterRaid = {
			type = "select",
			name = L["Filter Raid"],
			desc = L["Selects the action to perform when encountering damage meter data in raid chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterRaid = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterRaid
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterSay = {
			type = "select",
			name = L["Filter Say"],
			desc = L["Selects the action to perform when encountering damage meter data in say chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterSay = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterSay
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterWhisper = {
			type = "select",
			name = L["Filter Whisper"],
			desc = L["Selects the action to perform when encountering damage meter whisper"],
			set = function(info, value)
				SpamageMeters.db.profile.filterWhisper = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterWhisper
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
        	filterYell = {
			type = "select",
			name = L["Filter Yell"],
			desc = L["Selects the action to perform when encountering damage meter data in yell chat"],
			set = function(info, value)
				SpamageMeters.db.profile.filterYell = value
			end,
			get = function(info)
				return SpamageMeters.db.profile.filterYell
			end,
			values =	{	[1] = "Do Nothing",
						[2] = "Compress",
						[3] = "Suppress"
					}
		},
	},
}

function SpamageMeters:OnInitialize()
	-- Called when the addon is loaded
	self.db = LibStub("AceDB-3.0"):New("SpamageMetersDB", defaults, "Default")

	LibStub("AceConfig-3.0"):RegisterOptionsTable("SpamageMeters", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SpamageMeters", "SpamageMeters")
	self:RegisterChatCommand("spm", "ChatCommand")
	self:RegisterChatCommand("spamagemeters", "ChatCommand")
end

function SpamageMeters:OnEnable()
	-- Called when the addon is enabled

	self:RawHook("ChatFrame_MessageEventHandler","ParseChatEvent", true)

	--self:RegisterEvent("CHAT_MSG_CHANNEL")	-- Event for channel messages
	--self:RegisterEvent("CHAT_MSG_GUILD")	-- Event for guild chat messages
	--self:RegisterEvent("CHAT_MSG_OFFICER")	-- Event for officer chat messages	
	--self:RegisterEvent("CHAT_MSG_PARTY")	-- Event for party chat messages
	--self:RegisterEvent("CHAT_MSG_RAID")	-- Event for raid chat messages
	--self:RegisterEvent("CHAT_MSG_SAY")	-- Event for say chat messages
	--self:RegisterEvent("CHAT_MSG_WHISPER")	-- Event for whisper chat messages
	--self:RegisterEvent("CHAT_MSG_YELL")	-- Event for yell chat messages
end

function SpamageMeters:OnDisable()
	-- Called when the addon is disabled

end

function SpamageMeters:Debug(msg)
	-- Print the message to screen if debug is turned on
	if self.db.profile.debug and not msg:trim() == "" then
		self:Print(msg)
	end
end

function SpamageMeters:ChatCommand(input)
	-- Open dialog if no parameters, else do something with the parameters
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(SpamageMeters, "spm", "SpamageMeters", input)
	end
end

function SpamageMeters:ParseChatEvent(this, event, ...)
	local hide = false
	-- When getting a whisper, evaluate
	if event == "CHAT_MSG_WHISPER" and self.db.profile.filterWhisper == 3 then
		hide = true
	end
	
	if not hide then
		return self.hooks["ChatFrame_MessageEventHandler"](this, event, ...)
	end
	return
end
